Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -2106,351 +2212,363 @@
        i = nxlu
        DO  j = nys, nyn
-          IF( boundary_flags(j,i) == 5 )  THEN
-          
-             DO  k = nzb_u_inner(j,i)+1, nzt
-                u_comp(k)                = u(k,j,i) + u(k,j,i-1) - gu
-                swap_flux_x_local_u(k,j) = u_comp(k) *                         &
-                                           ( u(k,j,i) + u(k,j,i-1) ) * 0.25
-                swap_diss_x_local_u(k,j) = diss_2nd( u(k,j,i+2), u(k,j,i+1),   &
-                                                     u(k,j,i), u(k,j,i-1),     &
-                                                     u(k,j,i-1), u_comp(k),    &
-                                                     0.25, ddx )
-             ENDDO
-             
-          ELSE
-          
-             DO  k = nzb_u_inner(j,i)+1, nzt
-                u_comp(k)                = u(k,j,i) + u(k,j,i-1) - gu
-                swap_flux_x_local_u(k,j) = u_comp(k) * (                       &
-                                           37.0 * ( u(k,j,i) + u(k,j,i-1)   )  &
-                                         -  8.0 * ( u(k,j,i+1) + u(k,j,i-2) )  &
-                                         +        (u(k,j,i+2)+u(k,j,i-3) )  )  &
-                                         * adv_mom_5
-                swap_diss_x_local_u(k,j) = - ABS(u_comp(k)) * (                &
-                                           10.0 * ( u(k,j,i) - u(k,j,i-1)   )  &
-                                         -  5.0 * ( u(k,j,i+1) - u(k,j,i-2) )  &
-                                         +        ( u(k,j,i+2) - u(k,j,i-3) ) )&
-                                         * adv_mom_5
-             ENDDO
-             
-          ENDIF
-          
+          DO  k = nzb+1, nzb_max
+
+             u_comp(k)                = u(k,j,i) + u(k,j,i-1) - gu
+             swap_flux_x_local_u(k,j) = u_comp(k) * (                          &
+                          ( 37.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +     7.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1 &
+                          ) *                                                  &
+                                     ( u(k,j,i)   + u(k,j,i-1) )               &
+                   -      (  8.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( u(k,j,i+1) + u(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( u(k,j,i+2) + u(k,j,i-3) )               &
+                                                   )
+
+              swap_diss_x_local_u(k,j) = - ABS( u_comp(k) ) * (                &
+                          ( 10.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +     3.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1 &
+                          ) *                                                  &
+                                     ( u(k,j,i)   - u(k,j,i-1) )               &
+                   -      (  5.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( u(k,j,i+1) - u(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( u(k,j,i+2) - u(k,j,i-3) )               &
+                                                             )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp(k)         = u(k,j,i) + u(k,j,i-1) - gu
+             swap_flux_x_local_u(k,j) = u_comp(k) * (                          &
+                             37.0 * ( u(k,j,i) + u(k,j,i-1)   )                &
+                           -  8.0 * ( u(k,j,i+1) + u(k,j,i-2) )                &
+                           +        ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
+             swap_diss_x_local_u(k,j) = - ABS(u_comp(k)) * (                   &
+                             10.0 * ( u(k,j,i) - u(k,j,i-1)   )                &
+                           -  5.0 * ( u(k,j,i+1) - u(k,j,i-2) )                &
+                           +        ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
+
+          ENDDO
        ENDDO
 
        DO i = nxlu, nxr
 !       
-!--      The following loop computes the fluxes for the south boundary points
-         j = nys
-         IF ( boundary_flags(j,i) == 8 )  THEN
-!         
-!--         Compute southside fluxes for the south boundary of PE domain 
-            DO  k = nzb_u_inner(j,i)+1, nzt
-               v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
-               swap_flux_y_local_u(k) = v_comp *                              &
-                                        ( u(k,j,i) + u(k,j-1,i) ) * 0.25 
-               swap_diss_y_local_u(k) = diss_2nd( u(k,j+2,i), u(k,j+1,i),     &
-                                                  u(k,j,i), u(k,j-1,i),       &
-                                                  u(k,j-1,i), v_comp,         &
-                                                  0.25, ddy )
-            ENDDO
-            
-         ELSE
-         
-            DO  k = nzb_u_inner(j,i)+1, nzt
-               v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
-               swap_flux_y_local_u(k) = v_comp * (                             &
-                                        37.0 * ( u(k,j,i) + u(k,j-1,i)   )     &
-                                      -  8.0 * ( u(k,j+1,i) + u(k,j-2,i) )     &
-                                      +        ( u(k,j+2,i) + u(k,j-3,i) ) )   &
-                                      * adv_mom_5
-               swap_diss_y_local_u(k) = - ABS( v_comp ) * (                    &
-                                        10.0 * ( u(k,j,i) - u(k,j-1,i)   )     &
-                                      -  5.0 * ( u(k,j+1,i) - u(k,j-2,i) )     &
-                                      +        ( u(k,j+2,i) - u(k,j-3,i) ) )   &
-                                      * adv_mom_5
-            ENDDO
-            
-         ENDIF
-!         
-!--      Computation of interior fluxes and tendency terms
-         DO  j = nys, nyn
-            IF ( boundary_flags(j,i) /= 0 )  THEN
-!            
-!--            Degrade the order for Dirichlet bc. at the outflow boundary
-               SELECT CASE ( boundary_flags(j,i) )
-               
-                  CASE ( 1 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt
-                        u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                        flux_r(k) = ( u_comp(k) - gu ) * (                     &
-                                    7.0 * ( u(k,j,i+1) + u(k,j,i)   )          &
-                                  -       ( u(k,j,i+2) + u(k,j,i-1) ) )        &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS( u_comp(k) - gu ) * (                &
-                                    3.0 * ( u(k,j,i+1) - u(k,j,i) )            & 
-                                  -       ( u(k,j,i+2) - u(k,j,i-1) ) )        &
-                                  * adv_mom_3
-                     ENDDO
-                     
-                  CASE ( 2 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt
-                        u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                        flux_r(k) = ( u_comp(k) - gu ) *                      &
-                                    ( u(k,j,i+1) + u(k,j,i) ) * 0.25 
-                        diss_r(k) = diss_2nd( u(k,j,i+1), u(k,j,i+1),         &
-                                              u(k,j,i), u(k,j,i-1),           &
-                                              u(k,j,i-2), u_comp(k) ,0.25 ,ddx)
-                     ENDDO
-                     
-                  CASE ( 3 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt
-                        v_comp   = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                        flux_n(k) = v_comp * (                                 &
-                                    7.0 * ( u(k,j+1,i) + u(k,j,i)   )          &
-                                  -       ( u(k,j+2,i) + u(k,j-1,i) ) )        &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS( v_comp ) * (                        &
-                                    3.0 * ( u(k,j+1,i) - u(k,j,i)   )          & 
-                                  -       ( u(k,j+2,i) - u(k,j-1,i) ) )        &
-                                  * adv_mom_3
-                     ENDDO
-                     
-                  CASE ( 4 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt
-                        v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                        flux_n(k) = v_comp * ( u(k,j+1,i) + u(k,j,i) ) * 0.25
-                        diss_n(k) = diss_2nd( u(k,j+1,i), u(k,j+1,i),         &
-                                              u(k,j,i), u(k,j-1,i),           &
-                                              u(k,j-2,i), v_comp, 0.25, ddy )
-                     ENDDO
-                     
-                  CASE ( 5 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt        
-                        u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                        flux_r(k) = ( u_comp(k) - gu ) * (                     &
-                                    7.0 * ( u(k,j,i+1) + u(k,j,i)   )          &
-                                  -       ( u(k,j,i+2) + u(k,j,i-1) ) )        &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS( u_comp(k) - gu ) * (                &
-                                    3.0 * ( u(k,j,i+1) - u(k,j,i)   )          & 
-                                  -       ( u(k,j,i+2) - u(k,j,i-1) ) )        &
-                                  * adv_mom_3
-                     ENDDO
-                     
-                  CASE ( 7 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt                           
-                        v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                        flux_n(k) = v_comp * (                                 &
-                                    7.0 * ( u(k,j+1,i) + u(k,j,i)   )          &
-                                  -       ( u(k,j+2,i) + u(k,j-1,i) ) )        &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS( v_comp ) * (                        &
-                                    3.0 * ( u(k,j+1,i) - u(k,j,i)   )          & 
-                                  -       ( u(k,j+2,i) - u(k,j-1,i) ) )        &
-                                  * adv_mom_3
-                     ENDDO 
-                     
-                  CASE ( 8 )
-                     DO  k = nzb_u_inner(j,i)+1, nzt
-                        v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                        flux_n(k) = v_comp * (                                 &
-                                    7.0 * ( u(k,j+1,i) + u(k,j,i)   )          &
-                                  -       ( u(k,j+2,i) + u(k,j-1,i) ) )        &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS( v_comp ) * (                        &
-                                    3.0 * ( u(k,j+1,i) - u(k,j,i)   )          & 
-                                  -       ( u(k,j+2,i) - u(k,j-1,i) ) )        &
-                                  * adv_mom_3
-                     ENDDO  
-                     
-                  CASE DEFAULT
-                  
-               END SELECT
-!               
-!--            Compute the crosswise 5th order fluxes at the outflow
-               IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2 .OR.&
-                    boundary_flags(j,i) == 5 )  THEN
-              
-                  DO  k = nzb_u_inner(j,i)+1, nzt
-                     v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                     flux_n(k) = v_comp * (                                    &
-                                 37.0 * ( u(k,j+1,i) + u(k,j,i)   )            &
-                               -  8.0 * ( u(k,j+2,i) +u(k,j-1,i)  )            &
-                               +        ( u(k,j+3,i) + u(k,j-2,i) ) )          &
-                               * adv_mom_5
-                     diss_n(k) = - ABS( v_comp ) * (                           &
-                                 10.0 * ( u(k,j+1,i) - u(k,j,i)   )            &
-                               -  5.0 * ( u(k,j+2,i) - u(k,j-1,i) )            &
-                               +        ( u(k,j+3,i) - u(k,j-2,i) ) )          &
-                               * adv_mom_5
-                  ENDDO
-                  
-               ELSE
-               
-                  DO  k = nzb_u_inner(j,i)+1, nzt
-                     u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                     flux_r(k) = ( u_comp(k) - gu ) * (                        &
-                                 37.0 * ( u(k,j,i+1) + u(k,j,i)   )            &
-                               -  8.0 * ( u(k,j,i+2) + u(k,j,i-1) )            &
-                               +        ( u(k,j,i+3) + u(k,j,i-2) ) )          &
-                               * adv_mom_5
-                     diss_r(k) = - ABS( u_comp(k) - gu ) * (                   &
-                                 10.0 * ( u(k,j,i+1) - u(k,j,i)   )            &
-                               -  5.0 * ( u(k,j,i+2) - u(k,j,i-1) )            &
-                               +        ( u(k,j,i+3) - u(k,j,i-2) ) )          &
-                               * adv_mom_5
-                  ENDDO
-                  
-               ENDIF
-               
-            ELSE
-            
-               DO  k = nzb_u_inner(j,i)+1, nzt
-                  u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                  flux_r(k) = ( u_comp(k) - gu ) * (                           &
-                              37.0 * ( u(k,j,i+1) + u(k,j,i)   )               &
-                            -  8.0 * ( u(k,j,i+2) + u(k,j,i-1) )               &
-                            +        ( u(k,j,i+3) + u(k,j,i-2) ) )             &
-                            * adv_mom_5
-                  diss_r(k) = - ABS( u_comp(k) - gu ) * (                      &
-                              10.0 * ( u(k,j,i+1) - u(k,j,i)   )               &
-                            -  5.0 * ( u(k,j,i+2) - u(k,j,i-1) )               &
-                            +        ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
-
-                  v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                  flux_n(k) = v_comp * (                                       &
-                              37.0 * ( u(k,j+1,i) + u(k,j,i)   )               &
-                            -  8.0 * ( u(k,j+2,i) + u(k,j-1,i) )               &
-                            +        ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-                  diss_n(k) = - ABS( v_comp ) * (                              &
-                              10.0 * ( u(k,j+1,i) - u(k,j,i)   )               &
-                            -  5.0 * ( u(k,j+2,i) - u(k,j-1,i) )               &
-                            +        ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
-                                
-               ENDDO
-               
-            ENDIF
-            
-            DO  k = nzb_u_inner(j,i)+1, nzt
-            
-               tend(k,j,i) = tend(k,j,i) - (                                   &
-              ( flux_r(k) + diss_r(k)                                          &
-            -   swap_flux_x_local_u(k,j) - swap_diss_x_local_u(k,j)   ) * ddx  &
-            + ( flux_n(k) + diss_n(k)                                          &
-            -   swap_flux_y_local_u(k) - swap_diss_y_local_u(k)       ) * ddy )
-                  
-               swap_flux_x_local_u(k,j) = flux_r(k)   
-               swap_diss_x_local_u(k,j) = diss_r(k)
-               swap_flux_y_local_u(k)   = flux_n(k)     
-               swap_diss_y_local_u(k)   = diss_n(k)
-                      
-               sums_us2_ws_l(k,tn)  = sums_us2_ws_l(k,tn)                            &
-                 + ( flux_r(k)                                                 &
-                 * ( u_comp(k) - 2.0 * hom(k,1,1,0) )                          &
-                 / ( u_comp(k) - gu + 1.0E-20 )                                & 
-                 +   diss_r(k)                                                 &
-                 *   ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )                     &
-                 / ( ABS( u_comp(k) - gu) + 1.0E-20) )                         &
-                 *   weight_substep(intermediate_timestep_count)
-            ENDDO
-            sums_us2_ws_l(nzb_u_inner(j,i),tn) = sums_us2_ws_l(nzb_u_inner(j,i)+1,tn)
-         ENDDO
+!--       The following loop computes the fluxes for the south boundary points
+          j = nys
+          DO  k = nzb+1, nzb_max
+
+             v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
+             swap_flux_y_local_u(k) = v_comp * (                              &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( u(k,j,i)   + u(k,j-1,i) )              &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( u(k,j+1,i) + u(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( u(k,j+2,i) + u(k,j-3,i) )              &
+                                               )
+
+             swap_diss_y_local_u(k) = - ABS ( v_comp ) * (                    &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( u(k,j,i)   - u(k,j-1,i) )              &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( u(k,j+1,i) - u(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( u(k,j+2,i) - u(k,j-3,i) )              &
+                                                         )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
+             swap_flux_y_local_u(k) = v_comp * (                              &
+                           37.0 * ( u(k,j,i) + u(k,j-1,i)   )                 &
+                         -  8.0 * ( u(k,j+1,i) + u(k,j-2,i) )                 &
+                         +        ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
+             swap_diss_y_local_u(k) = - ABS(v_comp) * (                       &
+                           10.0 * ( u(k,j,i) - u(k,j-1,i)   )                 &
+                         -  5.0 * ( u(k,j+1,i) - u(k,j-2,i) )                 &
+                         +        ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
+
+          ENDDO
+!
+!--       Computation of interior fluxes and tendency terms
+          DO  j = nys, nyn
+
+             flux_t(0) = 0.0
+             diss_t(0) = 0.0
+             flux_d    = 0.0
+             diss_d    = 0.0
+
+             DO  k = nzb+1, nzb_max
+
+                u_comp(k) = u(k,j,i+1) + u(k,j,i)
+                flux_r(k) = ( u_comp(k) - gu ) * (                           &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j,i+1) + u(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j,i+2) + u(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j,i+3) + u(k,j,i-2) )                 &
+                                                 )
+
+                diss_r(k) = - ABS( u_comp(k) - gu ) * (                      &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j,i+1) - u(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j,i+2) - u(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j,i+3) - u(k,j,i-2) )                 &
+                                                     )
+
+                v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
+                flux_n(k) = v_comp * (                                       &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j+1,i) + u(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j+2,i) + u(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j+3,i) + u(k,j-2,i) )                 &
+                                                 )
+
+                diss_n(k) = - ABS ( v_comp ) * (                             &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j+1,i) - u(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j+2,i) - u(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j+3,i) - u(k,j-2,i) )                 &
+                                                      )
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),17,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),15,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),17,1)
+
+                w_comp    = w(k,j,i) + w(k,j,i-1)
+                flux_t(k) = w_comp  * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
+                                      )
+
+                diss_t(k) = - ABS( w_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+                                              )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx  &
+                     +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy  &
+                     +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
+                                                                    * ddzw(k)  &
+                      ) * 0.5
+
+                tend(k,j,i) = tend(k,j,i) - (                                  &
+                 ( flux_r(k) + diss_r(k)                                       &
+               -   swap_flux_x_local_u(k,j) - swap_diss_x_local_u(k,j) ) * ddx &
+               + ( flux_n(k) + diss_n(k)                                       &
+               -   swap_flux_y_local_u(k)   - swap_diss_y_local_u(k)   ) * ddy &
+               + ( flux_t(k) + diss_t(k)                                       &
+               -   flux_d    - diss_d                                          &
+                                                                  ) * ddzw(k)  &
+                                           ) + div * u(k,j,i)
+
+                swap_flux_x_local_u(k,j) = flux_r(k)
+                swap_diss_x_local_u(k,j) = diss_r(k)
+                swap_flux_y_local_u(k)   = flux_n(k)
+                swap_diss_y_local_u(k)   = diss_n(k)
+                flux_d                   = flux_t(k)
+                diss_d                   = diss_t(k)
+!
+!--             Statistical Evaluation of u'u'. The factor has to be applied
+!--             for right evaluation when gallilei_trans = .T. .
+                sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                     &
+                              + ( flux_r(k) *                                 &
+                                ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
+                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              +   diss_r(k) *                                 &
+                                  ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              *   weight_substep(intermediate_timestep_count)
+!
+!--             Statistical Evaluation of w'u'.
+                sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                   &
+                              + ( flux_t(k) + diss_t(k) )                     &
+                              *   weight_substep(intermediate_timestep_count)
+             ENDDO
+
+             DO  k = nzb_max+1, nzt
+
+                u_comp(k) = u(k,j,i+1) + u(k,j,i)
+                flux_r(k) = ( u_comp(k) - gu ) * (                            &
+                         37.0 * ( u(k,j,i+1) + u(k,j,i)   )                   &
+                       -  8.0 * ( u(k,j,i+2) + u(k,j,i-1) )                   &
+                       +        ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
+                diss_r(k) = - ABS( u_comp(k) - gu ) * (                       &
+                         10.0 * ( u(k,j,i+1) - u(k,j,i)   )                   &
+                       -  5.0 * ( u(k,j,i+2) - u(k,j,i-1) )                   &
+                       +        ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
+
+                v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
+                flux_n(k) = v_comp * (                                        &
+                         37.0 * ( u(k,j+1,i) + u(k,j,i)   )                   &
+                       -  8.0 * ( u(k,j+2,i) + u(k,j-1,i) )                   &
+                       +        ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
+                diss_n(k) = - ABS( v_comp ) * (                               &
+                         10.0 * ( u(k,j+1,i) - u(k,j,i)   )                   &
+                       -  5.0 * ( u(k,j+2,i) - u(k,j-1,i) )                   &
+                       +        ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),17,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),15,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),17,1)
+
+                w_comp    = w(k,j,i) + w(k,j,i-1)
+                flux_t(k) = w_comp  * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
+                                      )
+
+                 diss_t(k) = - ABS( w_comp ) * (                             &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+                                               )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx &
+                     +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy &
+                     +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) )       &
+                                                                    * ddzw(k) &
+                      ) * 0.5
+
+                 tend(k,j,i) = tend(k,j,i) - (                                 &
+                 ( flux_r(k) + diss_r(k)                                       &
+               -   swap_flux_x_local_u(k,j) - swap_diss_x_local_u(k,j) ) * ddx &
+               + ( flux_n(k) + diss_n(k)                                       &
+               -   swap_flux_y_local_u(k)   - swap_diss_y_local_u(k)   ) * ddy &
+               + ( flux_t(k) + diss_t(k)                                       &
+               -   flux_d    - diss_d                                          &
+                                                                  ) * ddzw(k)  &
+                                           ) + div * u(k,j,i)
+
+                 swap_flux_x_local_u(k,j) = flux_r(k)
+                 swap_diss_x_local_u(k,j) = diss_r(k)
+                 swap_flux_y_local_u(k)   = flux_n(k)
+                 swap_diss_y_local_u(k)   = diss_n(k)
+                 flux_d                   = flux_t(k)
+                 diss_d                   = diss_t(k)
+!
+!--              Statistical Evaluation of u'u'. The factor has to be applied
+!--              for right evaluation when gallilei_trans = .T. .
+                 sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                    &
+                              + ( flux_r(k) *                                 &
+                                ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
+                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              +   diss_r(k) *                                 &
+                                  ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              *   weight_substep(intermediate_timestep_count)
+!
+!--              Statistical Evaluation of w'u'.
+                 sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                  &
+                              + ( flux_t(k) + diss_t(k) )                     &
+                              *   weight_substep(intermediate_timestep_count)
        ENDDO
-
-!
-!--   Vertical advection, degradation of order near surface and top. 
-!--   The fluxes flux_d and diss_d at the surface are 0. Due to reasons of
-!--   statistical evaluation the top flux at the surface should be 0
-       DO i = nxlu, nxr
-          DO  j = nys, nyn
-             k = nzb_u_inner(j,i)+1
-!             
-!--         The fluxes flux_d and diss_d at the surface are 0. Due to static
-!--         reasons the top flux at the surface should be 0.
-            flux_t(nzb_u_inner(j,i)) = 0.0
-            diss_t(nzb_u_inner(j,i)) = 0.0
-            flux_d = flux_t(k-1)
-            diss_d = diss_t(k-1)             
-!
-!--         2nd order scheme (bottom)
-             w_comp    = w(k,j,i) + w(k,j,i-1)
-             flux_t(k) = w_comp * ( u(k+1,j,i) + u(k,j,i) ) * 0.25
-             diss_t(k) = diss_2nd( u(k+2,j,i), u(k+1,j,i), u(k,j,i),           &
-                                   0.0, 0.0, w_comp, 0.25, ddzw(k) )
-                                   
-             tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                       -   flux_d    -  diss_d       ) * ddzw(k)
-!
-!--         WS3 as an intermediate step (bottom)
-            k         = nzb_u_inner(j,i)+2
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            w_comp    = w(k,j,i) + w(k,j,i-1)
-            flux_t(k) = w_comp * (                                            &
-                        7.0 * ( u(k+1,j,i) + u(k,j,i)   )                     &
-                      -       ( u(k+2,j,i) + u(k-1,j,i) ) ) * adv_mom_3
-            diss_t(k) = - ABS( w_comp ) * (                                   &
-                        3.0 * ( u(k+1,j,i) - u(k,j,i)   )                     & 
-                      -       ( u(k+2,j,i) - u(k-1,j,i) ) ) * adv_mom_3
-
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    -  diss_d      ) * ddzw(k)
-!
-!WS5
-             DO  k = nzb_u_inner(j,i)+3, nzt-2
-
-                flux_d    = flux_t(k-1)
-                diss_d    = diss_t(k-1)
-                w_comp    = w(k,j,i) + w(k,j,i-1)
-                flux_t(k) = w_comp * (                                        &
-                            37.0 * ( u(k+1,j,i) + u(k,j,i)   )                &
-                          -  8.0 * ( u(k+2,j,i) + u(k-1,j,i) )                &
-                          +        ( u(k+3,j,i) + u(k-2,j,i) ) ) * adv_mom_5
-                diss_t(k) = - ABS( w_comp ) * (                               &
-                            10.0 * ( u(k+1,j,i) - u(k,j,i)   )                & 
-                          -  5.0 * ( u(k+2,j,i) - u(k-1,j,i) )                & 
-                          +        ( u(k+3,j,i) - u(k-2,j,i) ) ) * adv_mom_5
-
-                tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)           &
-                                          -   flux_d    -  diss_d   ) * ddzw(k)
-
-             ENDDO
-!
-!--          WS3 as an intermediate step (top)
-             k         = nzt-1
-             flux_d    = flux_t(k-1)
-             diss_d    = diss_t(k-1)
-             w_comp    = w(k,j,i) + w(k,j,i-1)
-             flux_t(k) = w_comp * (                                           &
-                         7.0 * ( u(k+1,j,i) + u(k,j,i) )                      &
-                       -       ( u(k+2,j,i) + u(k-1,j,i) ) ) * adv_mom_3
-             diss_t(k) = - ABS( w_comp ) * (                                  &
-                         3.0 * ( u(k+1,j,i) - u(k,j,i) )                      & 
-                       -       ( u(k+2,j,i) - u(k-1,j,i) ) ) * adv_mom_3
-                            
-             tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)              &
-                                       -   flux_d    -  diss_d      ) * ddzw(k)
-!
-!--         2nd order scheme (top)
-             k         = nzt
-             flux_d    = flux_t(k-1)
-             diss_d    = diss_t(k-1)
-             w_comp    = w(k,j,i) + w(k,j,i-1)
-             flux_t(k) = w_comp * ( u(k+1,j,i) + u(k,j,i) ) * 0.25
-             diss_t(k) = diss_2nd( u(nzt+1,j,i), u(nzt+1,j,i), u(k,j,i),      &
-                                   u(k-1,j,i), u(k-2,j,i), w_comp,            &
-                                   0.25, ddzw(k)) 
-
-             tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)              &
-                                       -   flux_d    -  diss_d      ) * ddzw(k)
-!
-!-- at last vertical momentum flux is accumulated
-            DO  k = nzb_u_inner(j,i), nzt
-               sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                           &
-                              + ( flux_t(k) + diss_t(k) )                      &
-                              *   weight_substep(intermediate_timestep_count)
-            ENDDO
           ENDDO
        ENDDO
+       sums_us2_ws_l(nzb,tn) = sums_us2_ws_l(nzb+1,tn)
 
 
